#!/bin/sh

TIMEOUT=60
IPW3945_ARGS="--quiet"

if [ "$1" == "--kill" ]; then
	killproc /sbin/ipw3945d
	exit 0
fi

if [ "$1" != "--delayed" ]; then
	if [ ! -w /var/run -o ! -e /sys/bus/pci/drivers/ipw3945/bind ]; then
		/bin/sh $0 --delayed &
		exit 0
	fi
fi

while ! test -w /var/run ; do
	i=$((i+1))
	test $i -gt $TIMEOUT && {
		echo "Timeout waiting for /var/run to become writable, skip starting ipw3945d" >&2 ;
		exit 1 ; }
	sleep 1
done
i=0
	
while ! test -e /sys/bus/pci/drivers/ipw3945/bind ; do
	i=$((i+1))
	test $i -gt $TIMEOUT && {
		echo "Timeout waiting for ipw3945 driver, skip starting ipw3945d" >&2 ;
		exit 1 ; }
	sleep 1
done

rm -f /var/run/ipw3945d.pid

exec /sbin/ipw3945d $IPW3945_ARGS
